classification
Title: Windows Python 3.7 installer broken by README.txt renamed to README.rst
Type: Stage: resolved
Components: Build, Windows Versions: Python 3.7, Python 3.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: steve.dower Nosy List: benjamin.peterson, georg.brandl, haypo, ned.deily, paul.moore, steve.dower, tim.golden, zach.ware
Priority: release blocker Keywords:

Created on 2017-02-16 09:48 by haypo, last changed 2017-02-20 09:52 by haypo. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 160 merged steve.dower, 2017-02-18 21:17
PR 161 merged steve.dower, 2017-02-18 21:30
Messages (17)
msg287924 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-02-16 09:48
Copy of https://github.com/python/cpython/pull/104#issuecomment-280174576
---
The Windows installer build picks up this readme file and distributes it as readme.txt (see Tools/msi/exe/exe_files.wxs, which now needs fixing).

I vote we should keep both so that we can distribute the file without rst formatting.

(As an aside, we also read the /LICENSE file, so if someone wants to come in and "fix" that too then they'll also need to update the installer.)
---

README.txt was renamed to README.rst by the PR#2:
https://github.com/python/cpython/pull/2

But README.rst was then modified by PR #70, PR #73 and #21.
msg287925 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-02-16 09:49
I proposed to convert README.rst to HTML and provide the HTML file in the Windows installer.
msg287938 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-16 13:32
I'm okay with including a html readme in the installer, but it has to be fully self-contained with no separate images or style sheets, and can't have any dependencies on reaching the network (until the user clicks a link, obviously).

My concern with just including the rst file as-is is the formatting, particularly of links, which are now much harder to read and copy than in the txt format.

In any case, we can't build a release until this is resolved one way or another. Perhaps RMs are happy to maintain the plain text version? Or we should let the github home page version diverge entirely from the actual readme and add back the original file. (I am only concerned about releasing it, so I'd like the people who maintain it to weigh in.)
msg287942 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-02-16 13:41
Another option (don't know if it's a good idea or not) is to not
include any README file in the installer. Is it really worth it? Why
not pointing to docs.python.org/3.7/ for example? Or suggest to
install the "Windows help file" package?

I just checked on my Fedora 25: the python3 package includes
/usr/share/doc/python3/README file.

I also checked if any other package include .rst doc: I found a lot of
them. As you may expect, most Python packages.

But for example, the "dnf" system tool used to manage packages only
uses a README.rst file which even includes a reference to an external
image:
https://raw.githubusercontent.com/rpm-software-management/dnf/gh-pages/logos/DNF_logo.png

You can find dnf README file at:
https://github.com/rpm-software-management/dnf/blob/master/README.rst

Other examples of packages including reST doc (excluding python*):
devassistant, koji, vex, fpaste, pypy, git-review, hawkey, subunit,
libbytesize, etc.

Ah just to be clear: Fedora packages provide reST as plain text, .rst
files, not HTML.
msg287951 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-16 15:48
I see absolutely no reason to use other projects on github as precedent here, as the developers have likely not made an explicit decision and are just shipping files that they already have. Github may be the home of our development now, but most users don't know or care.
msg288013 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2017-02-17 15:38
With the exception of the Travis and Codecov badges, `rst2html README.rst` produces a nicely self-contained HTML readme.

However, I'm not sure how useful that readme is on Windows.  Perhaps we should draft a new, simple readme for inclusion in the Windows installers that focuses on Python on Windows.
msg288015 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2017-02-17 15:41
Another option acceptable to me would be to simply leave out the readme entirely.  I wasn't even aware it was included until this issue came up :)
msg288028 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2017-02-17 17:57
FWIW, we do not include the top-level README in the macOS installer package.  Instead, we supply Mac-installer specific Welcome and Readme files that are displayed by the macOS Installer app during the installation process and the installer Readme is also installed for later reference.  These files are also the primary documentation for python.org macOS binary installer changes.  I agree with Zach that the top-level README doesn't seem very useful for binary installs.
msg288036 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-17 20:16
Okay. Unless someone volunteers to write a Windows specific one, I'll make the change to the installer to leave it out.

Anyone know how far the change has been backported?
msg288037 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2017-02-17 20:21
So far, to 3.6.  I don't really expect it to move back to 3.5, and 2.7's README is its own mess.
msg288039 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-02-17 20:50
Steve> Anyone know how far the change has been backported?

Ah, it seems like the README.txt => README.rst change was backported:
commit 1e8cc88a48a049b064f786bb4b97ea60b70dc504.

Since it breaks the Windows installer, I suggest to revert this change.

FYI my first motivation to convert README to reST was to have a nicer
homepage for http://github.com/python/cpython/ But the homepage uses
the README of the master branch.
msg288040 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2017-02-17 21:10
There were significant corrections to the README in that backport that should not be lost if we do de-restify the 3.6 readme.
msg288042 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-17 22:07
I don't think that removing the readme.txt from the install constitutes a breaking change (LICENSE would be a bigger deal), and removing the file from the installer sounds simpler than updating the readme.

Also, if you choose the 3.6 branch from the GitHub page you'll see whatever readme is in there, hence my thought that it would be backported.
msg288093 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-18 21:38
Pull request is at https://github.com/python/cpython/pull/160 and backport at https://github.com/python/cpython/pull/161
msg288094 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-19 00:12
New changeset 52a7e92e3d38d3d003552db6795deeeee75db2e4 by GitHub in branch 'master':
bpo-29579: Removes readme.txt from the installer. (#160)
https://github.com/python/cpython/commit/52a7e92e3d38d3d003552db6795deeeee75db2e4
msg288095 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2017-02-19 00:12
New changeset d372cda5cd46712c4e59262ec1ab981773b20bff by GitHub in branch '3.6':
bpo-29579: Removes readme.txt from the installer. (#161)
https://github.com/python/cpython/commit/d372cda5cd46712c4e59262ec1ab981773b20bff
msg288190 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-02-20 09:52
> I don't think that removing the readme.txt from the install constitutes a breaking change (LICENSE would be a bigger deal), and removing the file from the installer sounds simpler than updating the readme.

Ok, fine :-) Happy to see this issue closed ;-)
History
Date User Action Args
2017-02-20 09:52:36hayposetmessages: + msg288190
2017-02-19 03:28:35steve.dowersetstatus: open -> closed
resolution: fixed
stage: resolved
2017-02-19 00:12:08steve.dowersetmessages: + msg288095
2017-02-19 00:12:04steve.dowersetmessages: + msg288094
2017-02-18 21:38:58steve.dowersetmessages: + msg288093
2017-02-18 21:30:20steve.dowersetpull_requests: + pull_request126
2017-02-18 21:17:16steve.dowersetpull_requests: + pull_request125
2017-02-18 20:57:19steve.dowersetassignee: steve.dower
2017-02-17 22:07:24steve.dowersetmessages: + msg288042
versions: + Python 3.6
2017-02-17 21:10:14zach.waresetmessages: + msg288040
2017-02-17 20:50:54hayposetmessages: + msg288039
2017-02-17 20:21:12zach.waresetmessages: + msg288037
2017-02-17 20:16:38steve.dowersetmessages: + msg288036
2017-02-17 17:57:50ned.deilysetmessages: + msg288028
2017-02-17 15:41:04zach.waresetmessages: + msg288015
2017-02-17 15:38:24zach.waresetmessages: + msg288013
2017-02-16 15:48:50steve.dowersetmessages: + msg287951
2017-02-16 13:41:31hayposetmessages: + msg287942
2017-02-16 13:32:06steve.dowersetpriority: normal -> release blocker
nosy: + benjamin.peterson
messages: + msg287938

2017-02-16 09:49:00hayposetmessages: + msg287925
2017-02-16 09:48:36haypocreate